unit examunit;
interface
procedure geometry;
procedure test;
procedure help;
implementation
uses dos,crt,graph,mouse,lib3d,funcs;
const
 wherefiles='files\';
{===================================================}
{楤 ⥮!}
{===================================================}
procedure geometry;
type
 arrfile=Record
  pic:String;
  teor:String;
 end;
const
 numrowstext=8;
 numobjects=13;
var
 ay,az,posteor,posobj,i:Integer;
 xm,ym,keym,xmold,ymold:Word;
 rotateobj,rotatekey,redrawtext,changeobj,exitcheck:Boolean;
 data:Array[0..numobjects] of arrfile;
 key:Char;
begin
hidemouse;
keybuffoff;
key:=#0;
{===========}
data[0].pic:=   'geom.3d';
data[0].teor:=  'cont.teo';
data[1].pic:=   'mnog.3d';
data[1].teor:=  'mnog.teo';
data[2].pic:=   'prizm1.3d';
data[2].teor:=  'prizm1.teo';
data[3].pic:=   'prizm2.3d';
data[3].teor:=  'prizm2.teo';
data[4].pic:=   'prizm3.3d';
data[4].teor:=  'prizm3.teo';
data[5].pic:=   'parr1.3d';
data[5].teor:=  'parr1.teo';
data[6].pic:=   'parr2.3d';
data[6].teor:=  'parr2.teo';
data[7].pic:=   'kub.3d';
data[7].teor:=  'kub.teo';
data[8].pic:=   'pir1.3d';
data[8].teor:=  'pir1.teo';
data[9].pic:=   'pir2.3d';
data[9].teor:=  'pir2.teo';
data[10].pic:=   'pir3.3d';
data[10].teor:=  'pir3.teo';
data[11].pic:=  'cilind.3d';
data[11].teor:= 'cilind.teo';
data[12].pic:=  'konus.3d';
data[12].teor:= 'konus.teo';
data[13].pic:=  'spher.3d';
data[13].teor:= 'spher.teo';
for i:=0 to numobjects do
begin
data[i].pic:=wherefiles+data[i].pic;
data[i].teor:=wherefiles+data[i].teor;
end;
{===========}
exitcheck:=false;
redrawtext:=false;
rotatekey:=false;
posteor:=1;
posobj:=0;
ay:=0;az:=0;
rotateobj:=false;
cleardevice;
for i:=0 to 5000 do
begin
putpixel(random(640),random(480),random(15)+1);
end;

rectangle(40,40,600,300);{  ⨭}
rectangle(40,310,600,420);{  ⥪}

setfillstyle(1,0);{᪠   ⨭}
bar(41,41,599,299);

setfillstyle(1,7);{᪠    }
bar(580,310,600,420);

setfillstyle(1,7);{᪠ ⥪⮢ }
bar(41,311,579,419);

drawbutton(580,310,600,330);{Up    }
drawbutton(580,331,600,351);{^^Up    }

drawbutton(580,379,600,399);{down    }
drawbutton(580,400,600,420);{^^down    }
setcolor(15);
line(590,313,583,327);{ }
line(590,313,597,327);
line(583,327,597,327);

line(590,333,583,337);{ ^^}
line(590,333,597,337);
line(583,337,597,337);
line(590,343,583,347);
line(590,343,597,347);
line(583,347,597,347);

line(590,417,583,403);{ }
line(590,417,597,403);
line(583,403,597,403);

line(590,387,583,383);{ ^^}
line(590,387,597,383);
line(583,383,597,383);
line(590,397,583,393);
line(590,397,597,393);
line(583,393,597,393);

setfillstyle(1,7);{᪠    }
{ , ।, 室}
settextstyle(1,0,1);
SetTextJustify(1,1);
{}
drawbutton(40,430,140,460);
setcolor(15);
outtextxy(90,440,'');
{।}
drawbutton(500,430,600,460);
setcolor(15);
outtextxy(550,440,'।');
{室}
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);
drawfile3d(data[posobj].pic,320,170,40,40,600,300,0,ay,az);{砫쭠 ᮢ ꥪ}
drawtext(data[posobj].teor,posteor,50,320,numrowstext);{砫쭠 ᮢ ⥪}
resetmouse;
showmouse;
repeat
 readmousestate(xm,ym,keym);
 {
 ࠡ⪠  
 }
 if (keypressed) then key:=readkey
 else key:=#1;
 if (key = #0) then
 begin
 if (keypressed) then key:=readkey;
  if (key = #72{UP}) then
  begin
  dec(posteor);
  redrawtext:=true;
  end;
  if (key = #80{DOWN}) then
  begin
  inc(posteor);
  redrawtext:=true;
  end;
  if (key = #73{PAGEUP}) then
  begin
  dec(posteor,numrowstext);
  redrawtext:=true;
  end;
  if (key = #81{PAGEDOWN}) then
  begin
  inc(posteor,numrowstext);
  redrawtext:=true;
  end;
  if (key=#75{RIGHT}) then
  begin
   dec(posobj);
   if (posobj < 0) then
   begin
   posobj:=0;
   changeobj:=false;
   end
   else
   changeobj:=true;
  end;
  if (key=#77{LEFT}) then
  begin
   inc(posobj);
   if (posobj > numobjects) then
   begin
   posobj:=numobjects;
   changeobj:=false;
   end
   else
   changeobj:=true;
 end;
 end;
 if (key = #119) or (key = #87){w or W} then
 begin
  ay:=ay-1;
  rotatekey:=true;
 end;
 if (key = #115) or (key = #83){s or S} then
 begin
  ay:=ay+1;
  rotatekey:=true;
 end;
 if (key = #97) or (key = #65){a or A} then
 begin
  az:=az+1;
  rotatekey:=true;
 end;
 if (key = #100) or (key = #68){d or D} then
 begin
  az:=az-1;
  rotatekey:=true;
 end;
 if (key=#27) then
 begin
  exitcheck:=true;
 end;
 if (rotatekey) then
 begin
  hidemouse;
  if (ay > 359) then ay:=0;
  if (az > 359) then az:=0;
  if (ay < 0) then ay:=359;
  if (az < 0) then az:=359;
  setcolor(15);
  setfillstyle(1,0);
  bar(41,41,599,299);
  rectangle(40,40,600,300);{  ⨭}
  drawfile3d(data[posobj].pic,320,170,40,40,600,300,0,ay,az);
  showmouse;
  rotatekey:=false;
 end;

 {
 ࠡ⪠ 饭  ࠡ⪨   3d ꥪ
 ᯮ짮 ६:
 xmold ymold rotateobj ay az filename
  
 }
 if ((keym and 1)=1) and (not rotateobj) and
 ((xm >=40) and (ym >= 40) and (xm<=600) and (ym <= 300)) then
 begin
  xmold:=xm;
  ymold:=ym;
  hidemouse;
  rotateobj:=true;
 end;
 if ((keym and 1) <> 1) and (rotateobj) then
 begin
 rotateobj:=false;
 showmouse;
 end;
 if (rotateobj) and ((xm <> xmold) or (ym <> ymold)) then
 begin
   az:=az+(xmold-xm);
   ay:=ay+(ymold-ym);
  if (ay > 359) then ay:=0;
  if (az > 359) then az:=0;
  if (ay < 0) then ay:=359;
  if (az < 0) then az:=359;
  setcolor(15);
  setfillstyle(1,0);
  bar(41,41,599,299);
  rectangle(40,40,600,300);{  ⨭}
  {  rectangle(40,40,600,300);}
  drawfile3d(data[posobj].pic,320,170,40,40,600,300,0,ay,az);
  gotomouse(xmold,ymold);
 end;
 {
 END (ࠡ⪠ 饭  ࠡ⪨   3d ꥪ)
 }
 {
 ࠡ⪠ ᯮ짮 ⥮ਨ  
 }
if (xm > 580) and (ym > 310) and (xm < 600) and (ym < 330) and (keym and 1 = 1) then
begin
hidemouse;
drawbuttonin(580,310,600,330);{Up    }
setcolor(15);
line(591,314,584,328);{ }
line(591,314,598,328);
line(584,328,598,328);
showmouse;
repeat  readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(580,310,600,330);{Up    }
setcolor(15);
line(590,313,583,327);{ }
line(590,313,597,327);
line(583,327,597,327);
showmouse;
dec(posteor);
redrawtext:=true;
end;
if (xm > 580) and (ym > 331) and (xm < 600) and (ym < 351) and (keym and 1 = 1) then
begin
hidemouse;
drawbuttonin(580,331,600,351);{^^Up    }
setcolor(15);
line(591,334,584,338);{ ^^}
line(591,334,598,338);
line(584,338,598,338);
line(591,344,584,348);
line(591,344,598,348);
line(584,348,598,348);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(580,331,600,351);{^^Up    }
setcolor(15);
line(590,333,583,337);{ ^^}
line(590,333,597,337);
line(583,337,597,337);
line(590,343,583,347);
line(590,343,597,347);
line(583,347,597,347);
showmouse;
dec(posteor,numrowstext);
redrawtext:=true;
end;
if (xm > 580) and (ym > 379) and (xm < 600) and (ym < 399) and (keym and 1 = 1) then
begin
hidemouse;
drawbuttonin(580,379,600,399);{down    }
setcolor(15);
line(591,388,584,384);{ ^^}
line(591,388,598,384);
line(584,384,598,384);
line(591,398,584,394);
line(591,398,598,394);
line(584,394,594,394);
showmouse;
repeat  readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(580,379,600,399);{down    }
setcolor(15);
line(590,387,583,383);{ ^^}
line(590,387,597,383);
line(583,383,597,383);
line(590,397,583,393);
line(590,397,597,393);
line(583,393,597,393);
showmouse;
inc(posteor,numrowstext);
redrawtext:=true;
end;
if (xm > 580) and (ym > 400) and (xm < 600) and (ym < 420) and (keym and 1 = 1) then
begin
inc(posteor);
hidemouse;
drawbuttonin(580,400,600,420);{^^down    }
setcolor(15);
line(591,418,584,404);{ }
line(591,418,598,404);
line(584,404,598,404);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(580,400,600,420);{^^down    }
setcolor(15);
line(590,417,583,403);{ }
line(590,417,597,403);
line(583,403,597,403);
showmouse;
redrawtext:=true;
end;
if (redrawtext) then
begin
hidemouse;
setfillstyle(1,7);
bar(41,311,579,419);
drawtext(data[posobj].teor,posteor,50,320,numrowstext);
{resetmouse;
gotomouse(xm,ym);}
showmouse;
redrawtext:=false;
end;
 {
 END (ࠡ⪠ ᯮ짮 ⥮ਨ)
 }
{
ࠡ⪠  , ।, 室  
}
{}
if (xm > 40) and (ym > 430) and (xm < 140) and (ym < 460) and (keym and 1 = 1) then
begin
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbuttonin(40,430,140,460);
setcolor(15);
outtextxy(91,441,'');
SetTextJustify(0,0);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbutton(40,430,140,460);
setcolor(15);
outtextxy(90,440,'');
SetTextJustify(0,0);
showmouse;

dec(posobj);
if (posobj < 0) then
begin
posobj:=0;
changeobj:=false;
end
else
changeobj:=true;
end;
{।}
if (xm > 500) and (ym > 430) and (xm < 600) and (ym < 600) and (keym and 1 = 1) then
begin
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbuttonin(500,430,600,460);
setcolor(15);
outtextxy(551,441,'।');
SetTextJustify(0,0);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbutton(500,430,600,460);
setcolor(15);
outtextxy(550,440,'।');
SetTextJustify(0,0);
showmouse;
inc(posobj);
if (posobj > numobjects) then
begin
posobj:=numobjects;
changeobj:=false;
end
else
changeobj:=true;
end;
if (changeobj) then
begin
hidemouse;
redrawtext:=false;
posteor:=1;
ay:=0;az:=0;
rotateobj:=false;
setfillstyle(1,7);{᪠ ⥪⮢ }
bar(41,311,579,419);
setfillstyle(1,0);{᪠   ⨭}
bar(41,41,599,299);
drawfile3d(data[posobj].pic,320,170,40,40,600,300,0,ay,az);{砫쭠 ᮢ ꥪ}
drawtext(data[posobj].teor,posteor,50,320,numrowstext);{砫쭠 ᮢ ⥪}
changeobj:=false;
showmouse;
end;
if (xm > 270) and (ym > 430) and (xm < 370) and (ym < 600) and (keym and 1 = 1) then
begin
hidemouse;
SetTextJustify(1,1);
settextstyle(1,0,1);
drawbuttonin(270,430,370,460);
setcolor(15);
outtextxy(321,441,'');
showmouse;
exitcheck:=true;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);
showmouse;
end;
{  setfillstyle(1,0);
  setcolor(15);
  bar(0,0,139,39);
  outtextxy(10,10,inttostr(xm)+' '+inttostr(ym)+' '+inttostr(posobj));
}

until exitcheck;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
end;
{===================================================}
{楤 !}
{===================================================}
procedure test;
type
 qtype = Record
  q:String;
  answ:Array[1..4] of string;
  answer:Byte;
 end;
type
 pix = Record
  x:Integer;
  y:Integer;
 end;
var
 xm,ym,keym:Word;
 coordin:Array[1..6] of pix;
 letterh,ansh,answ,rec_count,va_count,day,mon,yea,dof,hou,min,sec,mls:Word;
 f:File of qtype;
 f2:Text;
 temp:qtype;
 a,t,name,tmps,tmps2:String;
 key:Char;
 gd,gm,pos,tmpi:integer;
 answerq:Byte;
 redraw,exitcheck:Boolean;
begin
keybuffoff;
hidemouse;
exitcheck:=false;
cleardevice;
coordin[1].x:=50;coordin[1].y:=70;   {}
coordin[2].x:=50;coordin[2].y:=150;  {⢥ 1}
coordin[3].x:=300;coordin[3].y:=150; {⢥ 2}
coordin[4].x:=50;coordin[4].y:=250;  {⢥ 3}
coordin[5].x:=300;coordin[5].y:=250; {⢥ 4}
coordin[6].x:=50;coordin[6].y:=350;  {⢥}
answ:=248;
ansh:=98;
letterh:=15;
for tmpi:=0 to 5000 do
begin
putpixel(random(640),random(480),random(15)+1);
end;
rectangle(40,40,600,420);{  ⥪}
setfillstyle(1,7);{᪠ ⥪⮢ }
bar(41,41,599,419);
setcolor(15);
settextstyle(1,0,1);
SetTextJustify(1,1);
{}
drawbutton(40,430,140,460);
setcolor(15);
outtextxy(90,440,'');
{।}
drawbutton(500,430,600,460);
setcolor(15);
outtextxy(550,440,'।');
{室}
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);
settextstyle(2,0,5);
setfillstyle(1,7);
outtextxy(100,80,'  䠬  ');
outtextxy(100,140,'<ENTER> -  ');
outtextxy(100,160,'<ESC> - ⬥');
outtextxy(100,180,'᫨  祣  ,   멤  ');
setcolor(14);
line(100,115,300,115);
name:=textln(100,100);
setcolor(15);
if (name = '') then exit;
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
{======================================================}
assign(f,wherefiles+'test.tpz');
{======================================================}
{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
{$I-}
reset(f);
{$I+}
if (ioresult <> 0) then
begin
outtextxy(50,50,'   䠩  ⮬!   .');
readkey;
exit;
end;
a:='';t:='';
for tmpi:=1 to filesize(f) do
begin
a:=a+' ';t:=t+' ';
end;
pos:=0;
redraw:=true;
resetmouse;
showmouse;
repeat
readmousestate(xm,ym,keym);
if (keypressed) then key:=readkey;
if (key = #0) then
begin
 if (keypressed) then key:=readkey;
 if (key = #77) then
 begin
  inc(pos);
  redraw:=true;
 end;
 if (key = #75) then
 begin
  dec(pos);
  redraw:=true;
 end;
 if (pos < 0) then pos:=0;
 if (pos > filesize(f)-1) then pos:=filesize(f)-1;
end;
   if (key in ['1'..'4']) then
   begin
    a[pos+1]:=key;
    val(key,answerq,tmpi);
    if (answerq <> temp.answer) then t[pos+1]:='0'
    else t[pos+1]:='1';
    inc(pos);
    redraw:=true;
    key:=#1;
   if (pos > filesize(f)-1) then pos:=filesize(f)-1;
   end;
   if (key=#27) then exitcheck:=true;

if (xm > coordin[2].x) and (ym > coordin[2].y) and (xm < (coordin[2].x + answ)) and (ym < (coordin[2].y + ansh))
and (keym and 1 = 1) then
begin
    a[pos+1]:='1';
    val('1',answerq,tmpi);
    if (answerq <> temp.answer) then t[pos+1]:='0'
    else t[pos+1]:='1';
    inc(pos);
    redraw:=true;
    if (pos > filesize(f)-1) then pos:=filesize(f)-1;
    repeat readmousestate(xm,ym,keym) until keym = 0;
end;

if (xm > coordin[3].x) and (ym > coordin[3].y) and (xm < (coordin[3].x + answ)) and (ym < (coordin[3].y + ansh))
and (keym and 1 = 1) then
begin
    a[pos+1]:='2';
    val('2',answerq,tmpi);
    if (answerq <> temp.answer) then t[pos+1]:='0'
    else t[pos+1]:='1';
    inc(pos);
    redraw:=true;
    if (pos > filesize(f)-1) then pos:=filesize(f)-1;
    repeat readmousestate(xm,ym,keym) until keym = 0;
end;
if (xm > coordin[4].x) and (ym > coordin[4].y) and (xm < (coordin[4].x + answ)) and (ym < (coordin[4].y + ansh))
and (keym and 1 = 1) then
begin
    a[pos+1]:='3';
    val('3',answerq,tmpi);
    if (answerq <> temp.answer) then t[pos+1]:='0'
    else t[pos+1]:='1';
    inc(pos);
    redraw:=true;
    if (pos > filesize(f)-1) then pos:=filesize(f)-1;
    repeat readmousestate(xm,ym,keym) until keym = 0;
end;
if (xm > coordin[5].x) and (ym > coordin[5].y) and (xm < (coordin[5].x + answ)) and (ym < (coordin[5].y + ansh))
and (keym and 1 = 1) then
begin
    a[pos+1]:='4';
    val('4',answerq,tmpi);
    if (answerq <> temp.answer) then t[pos+1]:='0'
    else t[pos+1]:='1';
    inc(pos);
    redraw:=true;
    if (pos > filesize(f)-1) then pos:=filesize(f)-1;
    repeat readmousestate(xm,ym,keym) until keym = 0;
end;


if (xm > 40) and (ym > 430) and (xm < 140) and (ym < 460) and (keym and 1 = 1) then
begin
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbuttonin(40,430,140,460);
setcolor(15);
outtextxy(91,441,'');
SetTextJustify(0,0);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbutton(40,430,140,460);
setcolor(15);
outtextxy(90,440,'');
SetTextJustify(0,0);
showmouse;
dec(pos);
if (pos < 0) then
begin
pos:=0;
end
else
redraw:=true;
end;
{।}
if (xm > 500) and (ym > 430) and (xm < 600) and (ym < 600) and (keym and 1 = 1) then
begin
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbuttonin(500,430,600,460);
setcolor(15);
outtextxy(551,441,'।');
SetTextJustify(0,0);
showmouse;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbutton(500,430,600,460);
setcolor(15);
outtextxy(550,440,'।');
SetTextJustify(0,0);
showmouse;
inc(pos);
if (pos > filesize(f)-1) then
begin
pos:=filesize(f)-1;
end
else
redraw:=true;
end;
if (xm > 270) and (ym > 430) and (xm < 370) and (ym < 600) and (keym and 1 = 1) then
begin
hidemouse;
SetTextJustify(1,1);
settextstyle(1,0,1);
drawbuttonin(270,430,370,460);
setcolor(15);
outtextxy(321,441,'');
showmouse;
exitcheck:=true;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);
showmouse;
end;

if (redraw) then
begin
   settextstyle(2,0,5);
   hidemouse;
   rectangle(40,40,600,420);
   setfillstyle(1,7);
   bar(41,41,599,419);
{   setfillstyle(1,1);}
setcolor(14);
for tmpi:=2 to 5 do
begin
setfillstyle(1,7);
setcolor(15);
if (a[pos+1] = '1') and (tmpi=2) then
begin
setfillstyle(1,8);
setcolor(14);
end;
if (a[pos+1] = '2') and (tmpi=3) then
begin
setfillstyle(1,8);
setcolor(14);
end;
if (a[pos+1] = '3') and (tmpi=4) then
begin
setfillstyle(1,8);
setcolor(14);
end;
if (a[pos+1] = '4') and (tmpi=5) then
begin
setfillstyle(1,8);
setcolor(14);
end;
bar(coordin[tmpi].x,coordin[tmpi].y,coordin[tmpi].x+answ,coordin[tmpi].y+ansh);
rectangle(coordin[tmpi].x,coordin[tmpi].y,coordin[tmpi].x+answ,coordin[tmpi].y+ansh);
end;
   {$I-}
   seek(f,pos);
   read(f,temp);
   {$I+}
   if ioresult <> 0 then
   begin
   close(f);
   closegraph;
   writeln('訡  饭  䠩  ⮬!');
   halt;
   end;
   str(pos+1,tmps);
   str(filesize(f),tmps2);
   setfillstyle(1,8);
   setcolor(14);
   bar(50,70,550,140);
   rectangle(50,70,550,140);
   setfillstyle(1,7);
   setcolor(15);
   outtextxy(50,60,' '+tmps+'/'+tmps2+':');
   viewlinestext(coordin[1].x+5,coordin[1].y+15,letterh,temp.q);
   viewlinestext(coordin[2].x+5,coordin[2].y+15,letterh,'1. '+temp.answ[1]);
   viewlinestext(coordin[3].x+5,coordin[3].y+15,letterh,'2. '+temp.answ[2]);
   viewlinestext(coordin[4].x+5,coordin[4].y+15,letterh,'3. '+temp.answ[3]);
   viewlinestext(coordin[5].x+5,coordin[5].y+15,letterh,'4. '+temp.answ[4]);
   viewlinestext(coordin[6].x+5,coordin[6].y+15,letterh,'⢥: '+a[pos+1]);
   redraw:=false;
   showmouse;
end;
until exitcheck;
rec_count:=filesize(f);
va_count:=0;
for tmpi:=1 to byte(t[0]) do
begin
if (t[tmpi] = '1') then inc(va_count);
end;
close(f);
assign(f2,'res.txt');
{$I-}
append(f2);
{$I+}
if ioresult <> 0 then
begin
rewrite(f2);
writeln(f2,'',#9,'業',#9,'',#9,'⢥',#9,'ࠢ쭮');
end;
getdate(yea,mon,day,dof);
gettime(hou,min,sec,mls);
writeln(f2,name,#9,((va_count/rec_count)*5):1:2,#9,day,'.',mon,'.',yea,' ',hou,':',min,#9,'''',a,'''',#9,'''',t,'''');
close(f2);
hidemouse;
{setcolor(14);}
setfillstyle(1,8);
setcolor(14);
bar(220,160,400,220);
rectangle(220,160,400,220);
settextstyle(1,0,1);
settextjustify(1,0);
outtextxy(310,180,' १:');
str((va_count/rec_count)*5:1:2,tmps);
outtextxy(310,205,tmps);
setcolor(15);
repeat
readmousestate(xm,ym,keym);
until (keym <> 0) or (keypressed);
end;
{===================================================}
{楤 }
{===================================================}

procedure help;
var
 pos:Integer;
 redrawtext:Boolean;
 xm,ym,keym,i:Word;
 exitcheck:Boolean;
 key:Char;
const
 numrowstext=30;
begin
keybuffoff;
pos:=0;
exitcheck:=false;
cleardevice;
for i:=0 to 5000 do
begin
putpixel(random(640),random(480),random(15)+1);
end;
rectangle(40,40,600,420);{  ⥪}

setfillstyle(1,7);{᪠    }
bar(580,40,600,420);

setfillstyle(1,7);{᪠ ⥪⮢ }
bar(41,41,579,419);

drawbutton(580,40,600,60);{Up    }
drawbutton(580,61,600,81);{^^Up    }

drawbutton(580,379,600,399);{down    }
drawbutton(580,400,600,420);{^^down    }
setcolor(15);
line(590,43,583,57);{ }
line(590,43,597,57);
line(583,57,597,57);

line(590,63,583,67);{ ^^}
line(590,63,597,67);
line(583,67,597,67);
line(590,73,583,77);
line(590,73,597,77);
line(583,77,597,77);

line(590,417,583,403);{ }
line(590,417,597,403);
line(583,403,597,403);

line(590,387,583,383);{ ^^}
line(590,387,597,383);
line(583,383,597,383);
line(590,397,583,393);
line(590,397,597,393);
line(583,393,597,393);
settextstyle(1,0,1);
SetTextJustify(1,1);
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);


resetmouse;showmouse;
repeat
if keypressed then key:=readkey;
if key=#0 then
begin
 if keypressed then key:=readkey;
 if key = #72 then
 begin
  dec(pos);
  redrawtext:=true;
  keybuffoff;
 end;
 if key = #80 then
 begin
  inc(pos);
  redrawtext:=true;
  keybuffoff;
 end;
 if key = #73 then
 begin
  dec(pos,numrowstext);
  redrawtext:=true;
  keybuffoff;
 end;
 if key = #81 then
 begin
  inc(pos,numrowstext);
  redrawtext:=true;
  keybuffoff;
 end;
end;
if (key = #27) then exitcheck:=true;
 readmousestate(xm,ym,keym);
  if (xm > 580) and (ym > 40) and (xm < 600) and (ym < 60) and (keym and 1 = 1) then
  begin
  hidemouse;
  drawbuttonin(580,40,600,60);{Up    }
  setcolor(15);
  line(591,44,584,58);{ }
  line(591,44,598,58);
  line(584,58,598,58);
  showmouse;
  repeat  readmousestate(xm,ym,keym) until keym = 0;
  hidemouse;
  drawbutton(580,40,600,60);{Up    }
  setcolor(15);
  line(590,43,583,57);{ }
  line(590,43,597,57);
  line(583,57,597,57);
  showmouse;
  dec(pos);
  redrawtext:=true;
  end;
  if (xm > 580) and (ym > 61) and (xm < 600) and (ym < 81) and (keym and 1 = 1) then
  begin
  hidemouse;
  drawbuttonin(580,61,600,81);{^^Up    }
  setcolor(15);
  line(591,64,584,68);{ ^^}
  line(591,64,598,68);
  line(584,68,598,68);
  line(591,74,584,78);
  line(591,74,598,78);
  line(584,78,598,78);
  showmouse;
  repeat  readmousestate(xm,ym,keym) until keym = 0;
  hidemouse;
  drawbutton(580,61,600,81);{^^Up    }
  setcolor(15);
  line(590,63,583,67);{ ^^}
  line(590,63,597,67);
  line(583,67,597,67);
  line(590,73,583,77);
  line(590,73,597,77);
  line(583,77,597,77);
  showmouse;
  dec(pos,numrowstext);
  redrawtext:=true;
  end;
  if (xm > 580) and (ym > 379) and (xm < 600) and (ym < 399) and (keym and 1 = 1) then
  begin
  hidemouse;
  drawbuttonin(580,379,600,399);{down    }
  setcolor(15);
  line(591,388,584,384);{ ^^}
  line(591,388,598,384);
  line(584,384,598,384);
  line(591,398,584,394);
  line(591,398,598,394);
  line(584,394,594,394);
  showmouse;
  repeat  readmousestate(xm,ym,keym) until keym = 0;
  hidemouse;
  drawbutton(580,379,600,399);{down    }
  setcolor(15);
  line(590,387,583,383);{ ^^}
  line(590,387,597,383);
  line(583,383,597,383);
  line(590,397,583,393);
  line(590,397,597,393);
  line(583,393,597,393);
  showmouse;
  inc(pos,numrowstext);
  redrawtext:=true;
  end;
  if (xm > 580) and (ym > 400) and (xm < 600) and (ym < 420) and (keym and 1 = 1) then
  begin
  inc(pos);
  hidemouse;
  drawbuttonin(580,400,600,420);{^^down    }
  setcolor(15);
  line(591,418,584,404);{ }
  line(591,418,598,404);
  line(584,404,598,404);
  showmouse;
  repeat readmousestate(xm,ym,keym) until keym = 0;
  hidemouse;
  drawbutton(580,400,600,420);{^^down    }
  setcolor(15);
  line(590,417,583,403);{ }
  line(590,417,597,403);
  line(583,403,597,403);
  showmouse;
  redrawtext:=true;
  end;
if (xm > 270) and (ym > 430) and (xm < 370) and (ym < 600) and (keym and 1 = 1) then
begin
hidemouse;
SetTextJustify(1,1);
settextstyle(1,0,1);
drawbuttonin(270,430,370,460);
setcolor(15);
outtextxy(321,441,'');
showmouse;
exitcheck:=true;
repeat readmousestate(xm,ym,keym) until keym = 0;
hidemouse;
drawbutton(270,430,370,460);
setcolor(15);
outtextxy(320,440,'');
SetTextJustify(0,0);
showmouse;
end;
   if (redrawtext) then
   begin
   hidemouse;
   setfillstyle(1,7);
   bar(41,41,579,419);
   drawtext(wherefiles+'help.txt',pos,50,50,numrowstext);
   showmouse;
   redrawtext:=false;
   end;
until exitcheck;
hidemouse;
end;
begin
end.