unit funcs;
Interface
 function inttostr(x:longInt): String;
 function strtoint(s:String): longInt;
 procedure drawtext(filename:String;var pos:Integer;x,y,numrows:Integer);
 procedure drawbutton(x1,y1,x2,y2:Integer);
 procedure drawbuttonin(x1,y1,x2,y2:Integer);
 function textln(x,y:Integer):String;
 procedure viewlinestext(x,y:Integer;letterh:Word;s:String);
 procedure keybuffoff;
Implementation
uses graph,crt;
  function inttostr(x:longInt): String;
  var
  d:String;
  begin
  str(x,d);
  inttostr:=d;
  end;
  function strtoint(s:String): longInt;
  var
  v:longInt;
  d:Integer;
  begin
  val(s,v,d);
  strtoint:=v;
  if d <> 0 then strtoint:=0;
  end;
  procedure drawtext(filename:String;var pos:Integer;x,y,numrows:Integer);
  var
   f:Text;
   numlines,i,font1:Integer;
   s:String;
  const
   letterh=12;
  begin
  font1:=installuserfont('FUNC');
   numlines:=0;
   assign(f,filename);
   {$I-}
   reset(f);
   {$I+}
   if ioresult <> 0 then exit;
   while not eof(f) do
   begin
    readln(f,s);
    inc(numlines);
   end;
   {$I-}
   reset(f);
   {$I+}
   if ioresult <> 0 then exit;
   if numlines = 0 then
    begin
    close(f);
    exit;
    end;
   if pos < 1 then pos:=1;
   if pos > numlines-numrows then pos:=numlines-numrows;
   for i:=1 to pos-1 do readln(f,s);
   setcolor(15);
   for i:=0 to numrows do
   begin
   readln(f,s);
   settextstyle(2,0,5);
   if (s[1] = '|') then
   begin
    settextstyle(font1,0,5);
    s:=copy(s,2,byte(s[0])-1);
   end;
   outtextxy(x,y+(letterh*i),s);
   end;
   close(f);
  end;
procedure drawbutton(x1,y1,x2,y2:Integer);
begin
setcolor(15);
line(x1,y1,x2,y1);
line(x1,y1,x1,y2);
setcolor(8);
line(x1,y2,x2,y2);
line(x2,y1,x2,y2);
setfillstyle(1,7);
bar(x1+1,y1+1,x2-1,y2-1);
end;
procedure drawbuttonin(x1,y1,x2,y2:Integer);
begin
setcolor(8);
line(x1,y1,x2,y1);
line(x1,y1,x1,y2);
setcolor(15);
line(x1,y2,x2,y2);
line(x2,y1,x2,y2);
setfillstyle(1,7);
bar(x1+1,y1+1,x2-1,y2-1);
end;
function textln(x,y:Integer):String;
var
 key:Char;
 exitcheck:Boolean;
 s:String;
begin
s:='';
exitcheck:=false;
repeat
key:=readkey;
case key of
 #32..#243:s:=s+key;
 #27:
 begin
 s:='';
 exitcheck:=true;
 end;
 #13:exitcheck:=true;
 #8:
 begin
 bar(x,y,x+textwidth(s),y+textheight(s));
 delete(s,byte(s[0]),1);
 end;
 end;
 bar(x,y,x+textwidth(s),y+textheight(s));
 outtextxy(x,y+8,s);
until exitcheck;
textln:=s;
end;
procedure viewlinestext(x,y:Integer;letterh:Word;s:String);
var
 s2:String;
 c:Word;
 i:Word;
 font1:Integer;
begin
font1:=installuserfont('FUNC');
c:=0;s2:='';
   for i:=1 to byte(s[0]) do
   begin
   if (s[i] <> '`') then
   begin
   s2:=s2+s[i];
   end
   else
   begin
   settextstyle(2,0,5);
   if (s2[1] = '|') then
   begin
   settextstyle(font1,0,5);
   s2:=copy(s2,2,byte(s2[0])-1);
   end;
   outtextxy(x,y+(letterh*c),s2);
   s2:='';
   inc(c);
   end;
   end;
   settextstyle(2,0,5);
   if (s2[1] = '|') then
   begin
   settextstyle(font1,0,5);
   s2:=copy(s2,2,byte(s2[0])-1);
   end;
   outtextxy(x,y+(letterh*c),s2);
end;
procedure keybuffoff;
begin
 while keypressed do readkey;
end;
begin

end.
